diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
index 1b3b32487..f29b8e6a1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
@@ -77,12 +77,12 @@ public class BlockModelTrapDoor<T extends BlockLogic> extends BlockModelStandard
         int orientation = data & 3;
         if(BlockLogicTrapDoor.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
-            return atlasIndices[index];
+            return blockTextures.get(index);
         } else {
             if(side.getAxis() == Axis.Y) {
-                return atlasIndices[1];
+                return blockTextures.get(Side.BOTTOM);
             }else {
-                return atlasIndices[3];
+                return blockTextures.get(Side.SOUTH);
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index a5877d724..1bc761e1a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -35,50 +35,55 @@ public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelSta
         super.renderBlockOnInventory(tessellator, 3, brightness, alpha, lightmapCoordinate);
     }
 
+    @Override
+    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+        return super.getBlockOverbrightTextureFromSideAndMeta(getRotatedSide(side, data), data);
+    }
+
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return atlasIndices[getTextureIndex(side, data)];
+        return super.getBlockTextureFromSideAndMetadata(getRotatedSide(side, data), data);
     }
 
-    public int getTextureIndex(Side side, int data) {
+    public Side getRotatedSide(Side side, int data) {
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(data);
         switch (dir) { // I love brute forcing fixes so much :3
             case SOUTH:
-                return side.getId();
+                return side;
             case EAST:
-                return side.getDirection().rotate(1).getId();
+                return side.getDirection().rotate(1).getSide();
             case NORTH:
-                return side.getDirection().rotate(2).getId();
+                return side.getDirection().rotate(2).getSide();
             case WEST:
-                return side.getDirection().rotate(3).getId();
+                return side.getDirection().rotate(3).getSide();
             case UP:
                 switch (side) {
                     case NORTH:
-                        return Side.TOP.getId();
+                        return Side.TOP;
                     case SOUTH:
-                        return Side.BOTTOM.getId();
+                        return Side.BOTTOM;
                     case TOP:
-                        return Side.SOUTH.getId();
+                        return Side.SOUTH;
                     case BOTTOM:
-                        return Side.NORTH.getId();
+                        return Side.NORTH;
                     default:
-                        return side.getId();
+                        return side;
                 }
             case DOWN:
                 switch (side) {
                     case NORTH:
-                        return Side.TOP.getId();
+                        return Side.TOP;
                     case SOUTH:
-                        return Side.BOTTOM.getId();
+                        return Side.BOTTOM;
                     case TOP:
-                        return Side.NORTH.getId();
+                        return Side.NORTH;
                     case BOTTOM:
-                        return Side.SOUTH.getId();
+                        return Side.SOUTH;
                     default:
-                        return side.getId();
+                        return side;
                 }
         }
-        return 0;
+        return Side.BOTTOM;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index b3d1576c5..1d9bdfe47 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -81,7 +81,7 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (mc.gameSettings.biomeWater.value) {
+			if (mc.gameSettings.biomeWater.value && !(mc.currentWorld != null && mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
index 17811a091..24bdb87e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterStill.java
@@ -80,7 +80,7 @@ public class DynamicTextureWaterStill extends DynamicTexture {
 			int b = 255;
 			int a = (int) (146.0F + var13 * 50.0F);
 
-			if (mc.gameSettings.biomeWater.value) {
+			if (mc.gameSettings.biomeWater.value && !(mc.currentWorld != null && mc.currentWorld.isRetro())) {
 				r = g = b = (r + g + b) / 3;
 			}
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
index e8fd35cdd..f1df137a7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/world/BlocksContainer.java
@@ -141,6 +141,12 @@ public class BlocksContainer implements WorldSource {
     public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
         return world.getSavedLightValue(layer, x, y, z);
     }
+
+    @Override
+    public boolean isRetro() {
+        return world.isRetro();
+    }
+
     public static class BlockEntry {
         public final int blockID;
         public final int blockMeta;
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 15b0c607b..9029ed847 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1063,6 +1063,11 @@ public class World implements WorldSource {
         }
     }
 
+    @Override
+    public boolean isRetro() {
+        return worldType.isRetro();
+    }
+
     public void setLightValue(LightLayer layer, int x, int y, int z, int value)
     {
         if(x < MIN_BLOCK_X || z < MIN_BLOCK_Z || x >= MAX_BLOCK_X || z > MAX_BLOCK_Z)
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 208a53557..6c036563b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -37,5 +37,7 @@ public interface WorldSource
     SeasonManager getSeasonManager();
     Biome getBlockBiome(int x, int y, int z);
     
-    public int getSavedLightValue(LightLayer layer, int x, int y, int z);
+    int getSavedLightValue(LightLayer layer, int x, int y, int z);
+
+    boolean isRetro();
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
index 472de83b1..c2bc4d8d7 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/ChunkCache.java
@@ -282,4 +282,9 @@ public class ChunkCache
 	public int getSavedLightValue(LightLayer layer, int x, int y, int z) {
 		return worldObj.getSavedLightValue(layer, x, y, z);
 	}
+
+    @Override
+    public boolean isRetro() {
+        return worldObj.isRetro();
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index 9190e849a..1c7425b77 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -31,6 +31,7 @@ public abstract class WorldType {
     private final int fillerBlockId;
     private final int dayNightCycleTicks;
     private final boolean mayRespawn;
+    private final boolean isRetro;
 
     public WorldType(Properties properties) {
         this.languageKey = properties.languageKey;
@@ -56,6 +57,7 @@ public abstract class WorldType {
         this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id();
         this.dayNightCycleTicks = properties.dayNightCycleTicks;
         this.mayRespawn = properties.mayRespawn;
+        this.isRetro = properties.isRetro;
     }
 
     public String getLanguageKey() {
@@ -118,6 +120,10 @@ public abstract class WorldType {
         return mayRespawn;
     }
 
+    public boolean isRetro() {
+        return isRetro;
+    }
+
     public void onWorldCreation(World world) { }
 
     public final int getYRange() {
@@ -248,6 +254,7 @@ public abstract class WorldType {
         private Block<?> fillerBlock = null;
         private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
         private boolean mayRespawn = false;
+        private boolean isRetro = false;
 
         private Properties(String languageKey) {
             this.languageKey = languageKey;
@@ -337,5 +344,10 @@ public abstract class WorldType {
             this.mayRespawn = true;
             return this;
         }
+
+        public Properties setRetro() {
+            this.isRetro = true;
+            return this;
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 1dadb8f1b..4d6fe1dc5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -79,6 +79,7 @@ public abstract class WorldTypes {
                     WorldTypeOverworld.defaultProperties("worldType.overworld.retro")
                             .seasonConfig(null)
                             .bounds(0, 127, 64)
+                            .setRetro()
             )
     );
     public static final WorldType OVERWORLD_ISLANDS = register(
@@ -155,6 +156,7 @@ public abstract class WorldTypes {
                     WorldTypeOverworld.defaultProperties("worldType.overworld.indev")
                             .seasonConfig(null)
                             .bounds(0, 127, 64)
+                            .setRetro()
             )
     );
     public static final WorldType OVERWORLD_SKYBLOCK = register(
